# coding: utf-8

"""
    Humanloop API

    The Humanloop API allows you to interact with Humanloop from your product or service.  You can do this through HTTP requests from any language or via our official Python SDK.  To install the official Python SDK, run the following command:  ```bash pip install humanloop ```  ---  Guides and further details about key concepts can be found in [our docs](https://humanloop.gitbook.io/humanloop-docs/).

    The version of the OpenAPI document: 4.0.0
    Generated by: https://konfigthis.com
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from humanloop import schemas  # noqa: F401


class ProviderApiKeys(
    schemas.DictSchema
):
    """
    This class is auto generated by Konfig (https://konfigthis.com)
    """


    class MetaOapg:
        
        class properties:
            openai = schemas.StrSchema
            ai21 = schemas.StrSchema
            mock = schemas.StrSchema
            anthropic = schemas.StrSchema
            __annotations__ = {
                "openai": openai,
                "ai21": ai21,
                "mock": mock,
                "anthropic": anthropic,
            }
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["openai"]) -> MetaOapg.properties.openai: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["ai21"]) -> MetaOapg.properties.ai21: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["mock"]) -> MetaOapg.properties.mock: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["anthropic"]) -> MetaOapg.properties.anthropic: ...
    
    @typing.overload
    def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["openai", "ai21", "mock", "anthropic", ], str]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["openai"]) -> typing.Union[MetaOapg.properties.openai, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["ai21"]) -> typing.Union[MetaOapg.properties.ai21, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["mock"]) -> typing.Union[MetaOapg.properties.mock, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["anthropic"]) -> typing.Union[MetaOapg.properties.anthropic, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["openai", "ai21", "mock", "anthropic", ], str]):
        return super().get_item_oapg(name)
    

    def __new__(
        cls,
        *args: typing.Union[dict, frozendict.frozendict, ],
        openai: typing.Union[MetaOapg.properties.openai, str, schemas.Unset] = schemas.unset,
        ai21: typing.Union[MetaOapg.properties.ai21, str, schemas.Unset] = schemas.unset,
        mock: typing.Union[MetaOapg.properties.mock, str, schemas.Unset] = schemas.unset,
        anthropic: typing.Union[MetaOapg.properties.anthropic, str, schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
    ) -> 'ProviderApiKeys':
        return super().__new__(
            cls,
            *args,
            openai=openai,
            ai21=ai21,
            mock=mock,
            anthropic=anthropic,
            _configuration=_configuration,
            **kwargs,
        )
