# coding: utf-8

"""
    Humanloop API

    The Humanloop API allows you to interact with Humanloop from your product or service.  You can do this through HTTP requests from any language or via our official Python SDK.  To install the official Python SDK, run the following command:  ```bash pip install humanloop ```  ---  Guides and further details about key concepts can be found in [our docs](https://humanloop.gitbook.io/humanloop-docs/).

    The version of the OpenAPI document: 4.0.0
    Generated by: https://konfigthis.com
"""

from datetime import datetime, date
import typing
from enum import Enum
from typing_extensions import TypedDict, Literal

from humanloop.type.chat_message import ChatMessage
from humanloop.type.provider_api_keys import ProviderApiKeys

RequiredChatDeployedRequest = TypedDict("RequiredChatDeployedRequest", {
    # Unique project name.
    "project": str,

    # The messages passed to the to provider chat endpoint.
    "messages": typing.List[ChatMessage],
    })

OptionalChatDeployedRequest = TypedDict("OptionalChatDeployedRequest", {
    # The inputs passed to the chat template.
    "inputs": typing.Dict[str, typing.Union[bool, date, datetime, dict, float, int, list, str, None]],

    # Identifies where the model was called from.
    "source": str,

    # API keys required by each provider to make API calls. The API keys provided here are not stored by Humanloop. If not specified here, Humanloop will fall back to the key saved to your organization.
    "provider_api_keys": ProviderApiKeys,

    # The number of chat responses.
    "num_samples": int,

    # If true, tokens will be sent as data-only server-sent events. If num_samples > 1, samples are streamed back independently.
    "stream": bool,

    # End-user ID passed through to provider call.
    "user": str,

    # Any additional metadata to record.
    "metadata": typing.Dict[str, typing.Union[bool, date, datetime, dict, float, int, list, str, None]],
    }, total=False)

class ChatDeployedRequest(RequiredChatDeployedRequest, OptionalChatDeployedRequest):
    pass
