# coding: utf-8

"""
    Humanloop API

    The Humanloop API allows you to interact with Humanloop from your product or service.  You can do this through HTTP requests from any language or via our official Python SDK.  To install the official Python SDK, run the following command:  ```bash pip install humanloop ```  ---  Guides and further details about key concepts can be found in [our docs](https://humanloop.gitbook.io/humanloop-docs/).

    The version of the OpenAPI document: 4.0.0
    Generated by: https://konfigthis.com
"""

from datetime import datetime, date
import typing
from enum import Enum
from typing_extensions import TypedDict, Literal

from humanloop.type.data_response import DataResponse
from humanloop.type.usage import Usage

RequiredCompletionResponse = TypedDict("RequiredCompletionResponse", {
    # Unique identifier of the parent project.
    "project_id": str,

    # Array containing the generation responses.
    "data": typing.List[DataResponse],

    # The raw responses returned by the model provider.
    "provider_responses": typing.List[typing.Union[bool, date, datetime, dict, float, int, list, str, None]],
    })

OptionalCompletionResponse = TypedDict("OptionalCompletionResponse", {
    # How many completions to make for each set of inputs.
    "num_samples": int,

    # Include the log probabilities of the top n tokens in the provider_response
    "logprobs": int,

    # The suffix that comes after a completion of inserted text. Useful for completions that act like inserts.
    "suffix": str,

    # End-user ID passed through to provider call.
    "user": str,

    # Counts of the number of tokens used and related stats.
    "usage": Usage,

    # Any additional metadata to record.
    "metadata": typing.Dict[str, typing.Union[bool, date, datetime, dict, float, int, list, str, None]],
    }, total=False)

class CompletionResponse(RequiredCompletionResponse, OptionalCompletionResponse):
    pass
