# coding: utf-8

"""
    Humanloop API

    The Humanloop API allows you to interact with Humanloop from your product or service.  You can do this through HTTP requests from any language or via our official Python SDK.  To install the official Python SDK, run the following command:  ```bash pip install humanloop ```  ---  Guides and further details about key concepts can be found in [our docs](https://humanloop.gitbook.io/humanloop-docs/).

    The version of the OpenAPI document: 4.0.0
    Generated by: https://konfigthis.com
"""

from datetime import datetime, date
import typing
from enum import Enum
from typing_extensions import TypedDict, Literal

from humanloop.type.src_external_app_models_v4_model_configs_model_config_response import SrcExternalAppModelsV4ModelConfigsModelConfigResponse

RequiredExperimentModelConfigResponse = TypedDict("RequiredExperimentModelConfigResponse", {
    # Number of datapoints with feedback associated to the experiment.
    "trials_count": int,

    # Whether the model config is active in the experiment. Only active model configs can be sampled from the experiment.
    "active": bool,

    # String ID of model config. Starts with `config_`.
    "id": str,

    # Display name of model config. If this is not set by the user, a friendly name is generated.
    "display_name": str,

    # Definition of the model config used in the experiment.
    "model_config": SrcExternalAppModelsV4ModelConfigsModelConfigResponse,

    "created_at": datetime,

    "updated_at": datetime,
    })

OptionalExperimentModelConfigResponse = TypedDict("OptionalExperimentModelConfigResponse", {
    # The mean performance of the model config.
    "mean": typing.Union[int, float],

    # The spread of performance of the model config.
    "spread": typing.Union[int, float],
    }, total=False)

class ExperimentModelConfigResponse(RequiredExperimentModelConfigResponse, OptionalExperimentModelConfigResponse):
    pass
