# coding: utf-8

"""
    Humanloop API

    The Humanloop API allows you to interact with Humanloop from your product or service.  You can do this through HTTP requests from any language or via our official Python SDK.  To install the official Python SDK, run the following command:  ```bash pip install humanloop ```  ---  Guides and further details about key concepts can be found in [our docs](https://humanloop.gitbook.io/humanloop-docs/).

    The version of the OpenAPI document: 4.0.0
    Generated by: https://konfigthis.com
"""

from datetime import datetime, date
import typing
from enum import Enum
from typing_extensions import TypedDict, Literal

from humanloop.type.feedback_type import FeedbackType

RequiredFeedbackResponse = TypedDict("RequiredFeedbackResponse", {
    # The type of feedback. The default feedback types available are 'rating', 'action', 'issue', 'correction', and 'comment'.
    "type": typing.Union[FeedbackType, str],

    # The feedback value to set. This would be the appropriate text for 'correction' or 'comment', or a label to apply for 'rating', 'action', or 'issue'.
    "value": str,

    # String ID of user feedback. Starts with `ann_`, short for annotation.
    "id": str,
    })

OptionalFeedbackResponse = TypedDict("OptionalFeedbackResponse", {
    # ID to associate the feedback to a previously logged datapoint.
    "data_id": str,

    # A unique identifier to who provided the feedback.
    "user": str,

    # User defined timestamp for when the feedback was created. 
    "created_at": datetime,
    }, total=False)

class FeedbackResponse(RequiredFeedbackResponse, OptionalFeedbackResponse):
    pass
