# coding: utf-8

"""
    Humanloop API

    The Humanloop API allows you to interact with Humanloop from your product or service.  You can do this through HTTP requests from any language or via our official Python SDK.  To install the official Python SDK, run the following command:  ```bash pip install humanloop ```  ---  Guides and further details about key concepts can be found in [our docs](https://humanloop.gitbook.io/humanloop-docs/).

    The version of the OpenAPI document: 4.0.0
    Generated by: https://konfigthis.com
"""

from datetime import datetime, date
import typing
from enum import Enum
from typing_extensions import TypedDict, Literal

from humanloop.type.categorical_feedback_label import CategoricalFeedbackLabel
from humanloop.type.feedback_type import FeedbackType

RequiredFeedbackTypeModel = TypedDict("RequiredFeedbackTypeModel", {
    # The type of feedback. The default feedback types available are 'rating', 'action', 'issue', 'correction', and 'comment'.
    "type": typing.Union[FeedbackType, str],
    })

OptionalFeedbackTypeModel = TypedDict("OptionalFeedbackTypeModel", {
    # The allowed values for categorical feedback types. Not populated for `correction` and `comment`.
    "values": typing.List[CategoricalFeedbackLabel],
    }, total=False)

class FeedbackTypeModel(RequiredFeedbackTypeModel, OptionalFeedbackTypeModel):
    pass
