# coding: utf-8

"""
    Humanloop API

    The Humanloop API allows you to interact with Humanloop from your product or service.  You can do this through HTTP requests from any language or via our official Python SDK.  To install the official Python SDK, run the following command:  ```bash pip install humanloop ```  ---  Guides and further details about key concepts can be found in [our docs](https://humanloop.gitbook.io/humanloop-docs/).

    The version of the OpenAPI document: 4.0.0
    Generated by: https://konfigthis.com
"""

from datetime import datetime, date
import typing
from enum import Enum
from typing_extensions import TypedDict, Literal

from humanloop.type.experiment_response import ExperimentResponse
from humanloop.type.feedback_types import FeedbackTypes
from humanloop.type.project_user_response import ProjectUserResponse
from humanloop.type.src_external_app_models_v4_model_configs_project_model_config_response import SrcExternalAppModelsV4ModelConfigsProjectModelConfigResponse

RequiredProjectResponse = TypedDict("RequiredProjectResponse", {
    # Project ID
    "id": str,

    # Project ID for internal Humanloop use.
    "internal_id": int,

    # Unique project name.
    "name": str,

    # Users associated to the project.
    "users": typing.List[ProjectUserResponse],

    # The count of datapoints that have been logged to the project.
    "data_count": int,

    "feedback_types": FeedbackTypes,

    # Unique ID of the team the project belongs to. Starts with `tm_`.
    "team_id": str,

    "created_at": datetime,

    "updated_at": datetime,
    })

OptionalProjectResponse = TypedDict("OptionalProjectResponse", {
    # Experiment that has been set as the project's active deployment. At most one of active_experiment and active_model_config can be set.
    "active_experiment": ExperimentResponse,

    # Model configuration that has been set as the project's active deployment. At most one of active_experiment and active_model_config can be set.
    "active_model_config": SrcExternalAppModelsV4ModelConfigsProjectModelConfigResponse,
    }, total=False)

class ProjectResponse(RequiredProjectResponse, OptionalProjectResponse):
    pass
