# coding: utf-8

"""
    Humanloop API

    The Humanloop API allows you to interact with Humanloop from your product or service.  You can do this through HTTP requests from any language or via our official Python SDK.  To install the official Python SDK, run the following command:  ```bash pip install humanloop ```  ---  Guides and further details about key concepts can be found in [our docs](https://humanloop.gitbook.io/humanloop-docs/).

    The version of the OpenAPI document: 4.0.0
    Generated by: https://konfigthis.com
"""

from datetime import datetime, date
import typing
from enum import Enum
from typing_extensions import TypedDict, Literal

from humanloop.type.positive_label import PositiveLabel

RequiredUpdateProjectRequest = TypedDict("RequiredUpdateProjectRequest", {
    })

OptionalUpdateProjectRequest = TypedDict("OptionalUpdateProjectRequest", {
    # ID for an experiment to set as the project's active deployment. Starts with 'exp_'. At most one of 'active_experiment_id' and 'active_model_config_id' can be set.
    "active_experiment_id": str,

    # ID for a model configuration to set as the project's active deployment. Starts with 'config_'. At most one of 'active_experiment_id' and 'active_model_config_id' can be set.
    "active_model_config_id": str,

    # The full list of labels to treat as positive user feedback.
    "positive_labels": typing.List[PositiveLabel],
    }, total=False)

class UpdateProjectRequest(RequiredUpdateProjectRequest, OptionalUpdateProjectRequest):
    pass
